# Copyright (C) 2004 by Dr. Dieter Maurer, Eichendorffstr. 23, D-66386 St. Ingbert, Germany
# see "LICENSE.txt" for details
#       $Id: ISearch.py,v 1.1.1.1 2004/08/14 14:27:55 dieter Exp $
'''Enumerator

provides an efficient way to enumerate the elements of a domain.
Unlike an 'ISearch' it can be used arbitrarily often.
'''

class Enumerator:
  '''abstract'''
  def check(self, elem):
    '''checks whether *elem* is in the domain.'''
    raise NotImplementedError

  def next(self, elem):
    '''the domain element following *elem* or 'None'.'''
    raise NotImplementedError
